<?php

namespace Drupal\field_quick_cardinality;

use Drupal\Core\Entity\EntityInterface;
use Drupal\field_ui\FieldConfigListBuilder as FieldUIFieldConfigListBuilder;

class FieldConfigListBuilder extends FieldUIFieldConfigListBuilder {

  public function buildHeader() {
    $build = parent::buildHeader();
    $this->injectBeforeLastElement($build, 'cardinality' , $this->t('Cardinality'));
    return $build;
  }

  public function buildRow(EntityInterface $field_config) {
    $row = parent::buildRow($field_config);
    $cardinality_output = ($field_config->getFieldStorageDefinition()->get("cardinality") > 0) ? $field_config->getFieldStorageDefinition()->get("cardinality") : $this->t("Unlimited");
    $this->injectBeforeLastElement($row['data'], "cardinality", $cardinality_output);
    return $row;
  }

  private function injectBeforeLastElement(&$array, $key, $value) {
    $last_key = array_key_last($array);
    $last_value = $array[$last_key];
    unset($array[$last_key]);
    $array[$key] = $value;
    $array[$last_key] = $last_value;
  }

}
